<template>
  <div class="flex flex-col w-full gap-3">
    <div class="container px-4 mx-auto my-8 sm:px-12 gap-3">
        <div class="flex justify-between w-full py-2">
    <label class="text-sm font-semibold ">Seccion {{ identificador.orden }} Galeria</label>
    <button @click="handleDelete" type="button" class="px-4 py-2 text-white bg-red-500 w-max">Eliminar</button>
        </div>
    <div class="flex w-full gap-3 pt-8">
      <div class="flex items-center gap-3 flex-nowrap">
        <span>Columnas</span>
        <select class="w-full py-2 mt-1 border border-gray-300 dark:bg-gray-800 shadow-sm form-select focus:outline-none focus:shadow-outline-blue focus:border-blue-300" v-model="columnCount">
          <option v-for="column in 12" :value="column" :key="'cols-' + column">
            {{ column }}
          </option>
        </select>
      </div>
      <div class="flex items-center gap-3 flex-nowrap">
        <span>Filas</span>
        <select class="w-full py-2 mt-1 border border-gray-300 dark:bg-gray-800 shadow-sm form-select focus:outline-none focus:shadow-outline-blue focus:border-blue-300" v-model="rowCount">
          <option :value="0">auto</option>
          <option v-for="row in 6" :value="row" :key="'rows-' + row">
            {{ row }}
          </option>
        </select>
      </div>
        <button

          data-bs-toggle="modal"
        :data-bs-target="'#exampleModal'+identificador.orden"
        type="button"
          class="px-4 py-2 text-white bg-blue-500 w-max"
        >
          Añadir elemento
        </button>

        <div
        class="modal fade"
        :id="'exampleModal'+identificador.orden"
        tabindex="-1"
        :aria-labelledby="'exampleModalLabel'+identificador.orden"
        aria-hidden="true"
      >
        <div class="modal-dialog">
          <div class="modal-content dark:bg-gray-800 dark:text-white">
            <div class="modal-header">
              <h5 class="font-semibold modal-title" :id="'exampleModalLabel'+identificador.orden">

              </h5>
              <button
                type="button"
                class="btn-close dark:text-white"
                data-bs-dismiss="modal"
                aria-label="Close"
              ></button>
            </div>
            <div class="modal-body">
              <div class="flex flex-col w-full gap-3">
                <label for="">Imagen</label>
                <input
                  type="file"
                  class="w-full"
                  @change="onFileChange"/>
              </div>
            </div>
            <div class="modal-footer">
              <button
                type="button"
                class="px-4 py-2 text-sm font-medium  transition focus:outline-none focus:ring-2 focus:ring-offset-2 dark:text-white"
                data-bs-dismiss="modal"
              >
                Cerrar
              </button>
              <button
                @click="handleAddColumnClick()"
                type="button"
                class="px-4 py-2 text-sm font-medium text-white transition bg-blue-600 hover:bg-blue-700 focus:outline-none focus:ring-2 focus:ring-offset-2 focus:ring-blue-500"
                data-bs-dismiss="modal"
              >
                Añadir
              </button>
            </div>
          </div>
        </div>
      </div>

    </div>
    </div>
    <div
      :class="[
        'w-full min-h-screen grid border border-dashed border-gray-800',
        `grid-cols-${gridClass.gridCols}`,gridClass.gridRows!=0?`grid-rows-${gridClass.gridRows}`:''
      ]"
    >
      <items @updateclass="handleUpdateclass" @deleteItem="handleDeleteItem" :index="index" v-for="(elemento, index) in elementos"
        :key="index" :elemento="elemento" :identificador="identificador" :idproject="idproject" :rowCount="rowCount" :columnCount="columnCount"></items>
    </div>
  </div>
</template>
<script>
import items from './v-item.vue'
export default {
  props: {
    identificador: {
      type: Object,
    },
    idproject:{
      type: Number,
    },
    index:{
      type: Number,
    },
  },
  data() {
    return {
      gridClass: "",
      elementos: [],
      columnCount: 1,
      rowCount: 1,
      image:null,
    };
  },
  components: {
    items,
  },
  mounted () {
    this.gridClass = this.identificador.content.class===undefined?{gridCols:1,gridRows:0}:this.identificador.content.class;
    this.elementos = this.identificador.content.img===undefined?[]:this.identificador.content.img;
     this.columnCount=this.gridClass.gridCols;
      this.rowCount=this.gridClass.gridRows;
    this.elementos.forEach((part,index,arreglo) => {
      arreglo[index]=
        {
        colSpan: "auto",
        rowSpan: "auto",
        classes: { columns: "col-span-auto", rows: "row-span-auto" },
        posicionXIni: "auto",
        posicionXFin: "auto",
        posicionYIni: "auto",
        posicionYFin: "auto",
        ...part,}
      ;

      });

  },
  methods: {
    handleDelete(){
      this.axios.delete(`/api/project/${this.idproject}/projectgallery/${this.identificador.orden}`).then(response => {
                // console.log(response.data);
      this.$emit('delete', this.index);
            });


    },
    onFileChange(event){
       //get file to input form and send to server by axios
      this.image = event.target.files[0];


    },
    handleDeleteItem(index){
    //   console.log(index);
      this.elementos.splice(index,1);
      this.handleUpdateclass();

    },
   handleUpdateclass(){

     this.axios.put(`/api/project/${this.idproject}/projectgallery/${this.identificador.orden}`,{
        content: {
          class: this.gridClass,
          img: this.elementos,
        }
      }).then((response) => {
        //console.log(response);
      }).catch((error) => {
        console.log(error);
      });
    //  console.log(this.elementos);
   },
    handleAddColumnClick() {

      // return;
      let formData = new FormData();
      formData.append('image', this.image);
      formData.append('type','addimage' );
      formData.append('carpeta',this.identificador.title );
      formData.append('idproject',this.idproject );
        let token=  document.head.querySelector('meta[name="csrf-token"]') ? document.head.querySelector('meta[name="csrf-token"]').content : '';
        formData.append('_token',token );
    fetch('/admin/projectgallery/add',{
        method:'POST',
        body:formData,
    })
    .then((response)=>{return response.json();})
    .then((data)=>{
        console.log(data);
        this.image=null;
        let columna = {
        colSpan: "auto",
        rowSpan: "auto",
        classes: { columns: "col-span-auto", rows: "row-span-auto" },
        posicionXIni: "auto",
        posicionXFin: "auto",
        posicionYIni: "auto",
        posicionYFin: "auto",
        src: data.src,
        class:""
      };
      this.elementos.push(columna);
      this.handleUpdateclass();
    });
     /* this.axios.post(`/api/project/${this.idproject}/projectgallery/upgrade/`, formData, {
        headers: {
          'Content-Type': 'multipart/form-data'
        }
      })
      .then(response => {
        this.image=null;
        let columna = {
        colSpan: "auto",
        rowSpan: "auto",
        classes: { columns: "col-span-auto", rows: "row-span-auto" },
        posicionXIni: "auto",
        posicionXFin: "auto",
        posicionYIni: "auto",
        posicionYFin: "auto",
        src: response.data.src,
        class:""
      };
      this.elementos.push(columna);
      this.handleUpdateclass();
      });*/

    },
  },
  watch: {
    columnCount: function (newVal, oldVal) {
      if (newVal != oldVal) {

        this.gridClass = {
          ...this.gridClass,
          gridCols: newVal,
        };
        this.handleUpdateclass();
      }
    },
    rowCount: function (newVal, oldVal) {
      if (newVal != oldVal) {
        this.gridClass = {
          ...this.gridClass,
          gridRows: newVal,
        };
        this.handleUpdateclass();
      }
    },
  },
};
</script>
